#ifndef OSSO_STATUSBAR_COMBO_H
#define OSSO_STATUSBAR_COMBO_H

#include <gtk/gtkwidget.h>
#include <libosso.h>
#include <gconf/gconf-client.h>

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


G_BEGIN_DECLS
#define HILDON_STATUS_BAR_COMBO_ICON_NAME      "qgn_stat_graph_base"
#define HILDON_STATUS_BAR_CPU_ICON_SIZE 38
#define HILDON_STATUS_BAR_CPU_PRIORITY  1

#if HILDONDESKTOP == 1
#define OSSO_TYPE_STATUSBAR_CPU (osso_statusbar_cpu_get_type())
#define OSSO_STATUSBAR_CPU(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), OSSO_TYPE_STATUSBAR_CPU, OssoStatusbarCpu))
#define OSSO_STATUSBAR_CPU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), OSSO_TYPE_STATUS_BAR_DISPLAY, OssoStatusbarCpuClass))
#define OSSO_IS_STATUSBAR_CPU(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), OSSO_TYPE_STATUSBAR_CPU))
#define OSSO_IS_STATUSBAR_CPU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), OSSO_TYPE_STATUSBAR_CPU))
#define OSSO_STATUSBAR_CPU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), OSSO_TYPE_STATUSBAR_CPU, OssoStatusbarCpuClass))

typedef struct _OssoStatusbarCpu OssoStatusbarCpu;
typedef struct _OssoStatusbarCpuClass OssoStatusbarCpuClass;

struct _OssoStatusbarCpu {
	StatusbarItem parent;
};

struct _OssoStatusbarCpuClass {
	StatusbarItemClass parent_class;
};

GType osso_statusbar_cpu_get_type(void);
#else
void combo_entry(HildonStatusBarPluginFn_st *fn);
void *combo_initialize(HildonStatusBarItem *item, GtkWidget **button);
void combo_destroy(void *data);
void combo_update(void *data, gint value1, gint value2, const gchar *str);
int combo_get_priority(void *data);
#endif

#define CPU_NUM_SAMPLES 32

typedef struct _OssoStatusbarCpuPrivate OssoStatusbarCpuPrivate;

struct _OssoStatusbarCpuPrivate {
	GtkWidget *icon;	/* Icon in StatusBar */
	GtkWidget *button;
	GConfClient *gcc;
	osso_context_t *osso;
	guint notify_id;
	guint gc_notify_id_scpu;
	guint gc_notify_id_smem;
	guint gc_notify_id_cpu;
	guint gc_notify_id_mem;
	guint gc_notify_id_clk;
	guint gc_notify_id_cpumax;
	guint gc_notify_id_maxed_cpu_secs;
	gint color_cpu;
	gint color_mem;
	gboolean clock;
	gulong clock_id;
	gboolean show_cpu;
	gboolean show_mem;
	gboolean notify_cpumax;
	gint maxed_cpu_secs; /* config value */

	guchar cpu_samples[CPU_NUM_SAMPLES];
	gint cpu_cur_sample;
	time_t maxed_cpu_last_notification;
};

G_END_DECLS
#endif /* OSSO_STATUSBAR_COMBO_H */
